/************************************************************************/
/* avltree-addl.h - AVLTree Additional header				*/
/************************************************************************/
/*
 *  (c)2021-2023 Todd Shadburn <tshadburn@opencomputingsolutions.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/************************************************************************/


#ifndef _AVLTREE_ADDL_H_
#define _AVLTREE_ADDL_H_

#include <stdint.h>
#include <cutil/avltree.h>


#define AVLTREE_ITER_ASCEND		1
#define AVLTREE_ITER_DESCEND		2

#define AVLTREE_MAX_DEPTH		48

#define AVLTREE_ITER_F_COMPLETE		1


typedef struct _avltree_iter_t avltree_iter_t;
struct _avltree_iter_t {
	AVLTree		*tree;

	int		flags;

	int		dir;
	AVLNode		*node;
	AVLNode		*stack[AVLTREE_MAX_DEPTH];
	int		stack_idx;
};


avltree_iter_t *avltree_iter_new(AVLTree *tree, int direction);
int avltree_iter_free(avltree_iter_t *iter);
void *avltree_iter_next(avltree_iter_t *iter);



#endif


